#include <windows.h>
#include <stdio.h>
#include <time.h>

// ASCII to ANSI character table
byte ASCII_Table[128] =
{
	199, 252, 233, 226, 228, 224, 229, 231, 234, 235, 232, 239, 238, 236, 196,
	197, 201, 230, 198, 244, 246, 242, 251, 249, 255, 214, 220, 248, 163, 216,
	215, 131, 225, 237, 243, 250, 241, 209, 170, 186, 191, 174, 172, 189, 188,
	161, 171, 187, 176, 177, 178, 179, 180, 193, 194, 192, 169, 185, 186, 187,
	188, 162, 165, 191, 192, 193, 194, 195, 196, 134, 227, 195, 200, 201, 202,
	203, 204, 205, 135, 164, 240, 208, 202, 203, 200, 213, 205, 206, 207, 217,
	218, 219, 220, 166, 204, 223, 211, 223, 212, 210, 245, 213, 181, 254, 222,
	218, 219, 217, 253, 221, 175, 180, 173, 177, 242, 190, 182, 167, 247, 184,
	176, 168, 183, 185, 179, 178, 254, 160
};
char* AsciiToAnsi(char *asciistr) {
	byte	*spos = (byte*)asciistr;

	while(*spos) {
		if(*spos > 127) *spos = ASCII_Table[*spos - 128];
		spos += 1;
	}
	return asciistr;
}

// ANSI to ASCII character table
byte ANSI_Table[128] =
{
	 63,  63,  39, 159,  34,  46, 197, 206,  94,  37,  83,  60,  79,  63,  90,
	 63,  63,  39,  39,  34,  34,   7,  45,  45, 126,  84, 115,  62, 111,  63,
	122,  89, 255, 173, 189, 156, 207, 190, 221, 245, 249, 184, 166, 174, 170,
	240, 169, 238, 248, 241, 253, 252, 239, 230, 244, 250, 247, 251, 167, 175,
	172, 171, 243, 168, 183, 181, 182, 199, 142, 143, 146, 128, 212, 144, 210,
	211, 222, 214, 215, 216, 209, 165, 227, 224, 226, 229, 153, 158, 157, 235,
	233, 234, 154, 237, 232, 225, 133, 160, 131, 198, 132, 134, 145, 135, 138,
	130, 136, 137, 141, 161, 140, 139, 208, 164, 149, 162, 147, 228, 148, 246,
	155, 151, 163, 150, 129, 236, 231, 152
};
char* AnsiToAscii(char *ansistr) {
	byte	*spos = (byte*)ansistr;

	while(*spos) {
		if(*spos > 127) *spos = ANSI_Table[*spos - 128];
		spos += 1;
	}
	return ansistr;
}

enum LangStrings {
	strWarningWindowsNT,
	strDescriptionApp,
	strWarningArgumentS,
	strWarningArgumentF,
	strWarningArgumentAF,
	strWarningUnknownArg,
	strOutputArray,
	strOutputNormal,
	strErrorEvent6009,
	strErrorMalloc,
	strErrorOpenEventLog
};

LPTSTR strings[strErrorOpenEventLog];

void setstrings() {
	LANGID	lang;

	lang = GetUserDefaultLangID();

	switch(lang) {
	// german language strings
	case 0x0407:
	case 0x0807:
	case 0x0c07:
	case 0x1007:
	case 0x1407:
		strings[strWarningWindowsNT]	= "Uptime kann nur auf Windows NT/2000/XP-Computern ausgefhrt werden!\n";
		strings[strDescriptionApp]		= "\nUptime bestimmt die Laufzeit des angegebenen Windows NT/2000/XP-Computers (engl. up time). Die Laufteit ist die seit dem letzten Systemstart vergangene Zeit.\n"
										  "Copyright C2002 Michael Berthold\n"
										  "URL: http://www.bertel.de/software/uptime\n\n"
										  "Syntax: uptime {[/a | /f <Format>] [/s <Computer>] | /?}\n\n"
										  "/a (Optional) Legt die Ausgabe der Zeit in separaten Zeilen fest.\n"
										  "   Besonders ntzlich, wenn die Ausgabe werterverarbeitet werden soll\n"
										  "   Dieses Argument kann nicht zusammen mit /f verwendet werden\n\n"
										  "/f (Optional) Legt ein konkretes Format fr die Ausgabe der Zeit fest.\n"
										  "   Das Format kann Platzhalter und Steuerzeichen enthalten:\n"
										  "   %%Y=Jahre, %%D=Tage, %%H=Stunden, %%M=Minuten, %%S=Sekunden, %%%%=Prozentzeichen\n"
										  "   \\n=Zeilenumbruch, \\r=Zeilenanfang, \\t=Tabulator, \\\\=Backslash\n"
										  "   Dieses Argument kann nicht zusammen mit /a verwendet werden\n\n"
										  "/s (Optional) Bestimmt den Namen des zu befragenden Computers <Computer>.\n"
										  "   NetBIOS-Name, DNS-Name oder IP-Adresse ist mglich\n\n"
										  "/? Zeigt diese Hilfsinformationen an.\n"
										  "   Dieses Argument muss allein angegeben werden\n\n"
										  "Beispiele:\n"
										  "uptime /a\n"
										  "uptime /s 127.0.0.1\n"
										  "uptime /a /s Compi12\n"
										  "uptime /f \"%%Y+%%D %%H:%%M:%%S\"\n"
										  "uptime /?\n";
		strings[strWarningArgumentS]	= "Das Argument /s muss von einem Computernamen gefolgt werden!\n"
										  "Geben Sie fr Hilfe 'uptime /?' ein.\n";
		strings[strWarningArgumentF]	= "Das Argument /f muss vom gewnschten Format gefolgt werden!\n"
										  "Geben Sie fr Hilfe 'uptime /?' ein.\n";
		strings[strWarningArgumentAF]	= "Die Argumente /a und /f knnen nicht gemeinsam verwendet werden!\n"
										  "Geben Sie fr Hilfe 'uptime /?' ein.\n";
		strings[strWarningUnknownArg]	= "Das Argument %s ist nicht bekannt!\n"
										  "Geben Sie fr Hilfe 'uptime /?' ein.\n";
		strings[strOutputArray]			= "%d Jahre\n%d Tage\n%d Stunden\n%d Minuten\n%d Sekunden\n";
		strings[strOutputNormal]		= "Laufzeit: %d Jahre, %d Tage, %d Stunden, %d Minuten und %d Sekunden.\n";
		strings[strErrorEvent6009]		= "Ereignis 6009 wurde im Ereignisprotokoll 'System' nicht gefunden!\n"
										  "ReadEventLog-Fehler: %sminNumberOfBytesNeeded: %d\n";
		strings[strErrorMalloc]			= "malloc-Fehler: %s";
		strings[strErrorOpenEventLog]	= "OpenEventLog-Fehler: %s";
		break;
	// default are english language strings
	default:
		strings[strWarningWindowsNT]	= "Uptime can be executed on Windows NT/2000/XP computers only!\n";
		strings[strDescriptionApp]		= "\nUptime retrieves the up time of the specified Windows NT/2000/XP computer. The up time is the time gone since the last system boot.\n"
										  "Copyright C2002 by Michael Berthold\n"
										  "URL: http://www.bertel.de/software/uptime\n\n"
										  "usage: uptime {[/a] [/s <computer>] | /?}\n\n"
										  "/a (optional) specifies that the output time is written in separate lines.\n"
										  "   especially useful when the output has to be processed\n"
										  "   this argument cannot be combined with /f\n\n"
										  "/f (optional) specifies a user defined output time format.\n"
										  "   wildcards and escape sequences can be used:\n"
										  "   %%Y=years, %%D=days, %%H=hours, %%M=minutes, %%S=seconds, %%%%=percent character\n"
										  "   \\n=new line, \\r=line feed, \\t=tab, \\\\=backslash\n"
										  "   this argument cannot be combined with /a\n\n"
										  "/s (optional) specifies the name of the target computer <computer>.\n"
										  "   NetBIOS name, DNS name or IP address is possible\n\n"
										  "/? shows uptime help information.\n"
										  "   this argument must be set alone\n\n"
										  "Examples:\n"
										  "uptime /a\n"
										  "uptime /s 127.0.0.1\n"
										  "uptime /a /s Compi12\n"
										  "uptime /f \"%%Y+%%D %%H:%%M:%%S\"\n"
										  "uptime /?\n";
		strings[strWarningArgumentS]	= "The argument /s must be followed by a computer name!\n"
										  "Type 'uptime /?' to get help.\n";
		strings[strWarningArgumentF]	= "The argument /f must be followed by the user defined format!\n"
										  "Type 'uptime /?' to get help.\n";
		strings[strWarningArgumentAF]	= "The arguments /a and /f cannot be combined!\n"
										  "Type 'uptime /?' to get help.\n";
		strings[strWarningUnknownArg]	= "The argument %s is not known!\n"
										  "Type 'uptime /?' to get help.\n";
		strings[strOutputArray]			= "%d years\n%d days\n%d hours\n%d minutes\n%d seconds\n";
		strings[strOutputNormal]		= "Up time: %d years, %d days, %d hours, %d minutes, and %d seconds.\n";
		strings[strErrorEvent6009]		= "Event 6009 not found in system log!\n"
										  "ReadEventLog error: %sminNumberOfBytesNeeded: %d\n";
		strings[strErrorMalloc]			= "malloc error: %s";
		strings[strErrorOpenEventLog]	= "OpenEventLog error: %s";
	}
}

LPTSTR strerror(DWORD code) {
	LPTSTR	lpMsgBuf;
	if(FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL,
	code, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&lpMsgBuf, 0, NULL)) {
		return AnsiToAscii(lpMsgBuf);
	} else {
		return NULL;
	}
}

int main(int argc, char* argv[])
{
	const int esCharCount = 4;
	const char esChars[] = {'\\', 'n', 'r', 't'};
	const char esValues[] = {'\\', '\n', '\r', '\t'};

	const int wcCharCount = 6;
	const int wcYears = 0;
	const int wcDays = 1;
	const int wcHours = 2;
	const int wcMinutes = 3;
	const int wcSeconds = 4;
	const int wcPercent = 5;
	const char wcChars[] = {'Y', 'D', 'H', 'M', 'S', '%'};
	WORD wcValues[wcCharCount];

	OSVERSIONINFO	versionInfo;
	HANDLE			hEventLog;
	_EVENTLOGRECORD	*buffer;
	DWORD			bufferSize, recordNumber, bytesRead, minNumberOfBytesNeeded;
	WORD			eventID;
	LPTSTR			lpFormat = NULL, lpMsgBuf, lpEventSource, lpStrPos, lpFormatPos;
	BOOL			arrayOut = FALSE, result, found = FALSE;
	int				i, returnCode = 0;
	time_t			eventTime, sysTime;
	struct tm		*elapsedTime;
	char			computer[128];

	setstrings();
	computer[0] = 0;

	// checkt system for language info

	versionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if(GetVersionEx(&versionInfo)) {
		if(versionInfo.dwPlatformId != VER_PLATFORM_WIN32_NT) {
			printf(strings[strWarningWindowsNT]);
			return -1;
		}
	} else {
		lpMsgBuf = strerror(GetLastError());
		if(lpMsgBuf) {
			printf("GetVersionEx error: %s", lpMsgBuf);
			LocalFree((LPVOID)lpMsgBuf);
		}
		return -1;
	}

	// validate command line arguments

	i = 1;
	while(argc > i) {
		if(argv[i][0] == '/') {
			switch(argv[i][1]) {
				case '?':
					printf(strings[strDescriptionApp]);
					return 0;
				case 'a':
					if(!lpFormat) {
						arrayOut = TRUE;
						i++;
					} else {
						printf(strings[strWarningArgumentAF]);
						return -1;
					}
					break;
				case 's':
					i++;
					if(argc > i) {
						_snprintf(computer, 128, "\\\\%s", argv[i]);
						i++;
					} else {
						printf(strings[strWarningArgumentS]);
						return -1;
					}
					break;
				case 'f':
					if(!arrayOut) {
						i++;
						if(argc > i) {
							lpFormat = argv[i];
							i++;
						} else {
							printf(strings[strWarningArgumentF]);
							return -1;
						}
					} else {
						printf(strings[strWarningArgumentAF]);
						return -1;
					}
					break;
				default:
					printf(strings[strWarningUnknownArg], argv[i]);
					return -1;
			}
		} else {
			printf(strings[strWarningUnknownArg], argv[i]);
			return -1;
		}
	}

	// lookup startup entry in event log and print out up time

	hEventLog = OpenEventLog(computer, "System");
	if(hEventLog) {
		bufferSize = 1024;
		buffer = (_EVENTLOGRECORD*)malloc(bufferSize);
		if(buffer) {
			result = ReadEventLog(hEventLog, EVENTLOG_SEQUENTIAL_READ | EVENTLOG_BACKWARDS_READ, 0, buffer, bufferSize, &bytesRead, &minNumberOfBytesNeeded);
			recordNumber = buffer->RecordNumber;
			while(result) {
				if(buffer->EventType == EVENTLOG_INFORMATION_TYPE) {
					eventID = LOWORD(buffer->EventID);
					if(eventID == 6009) {
						lpEventSource = (LPTSTR)buffer;
						lpEventSource += sizeof(_EVENTLOGRECORD);
						if(!stricmp(lpEventSource, "eventlog")) {
							eventTime = time(&sysTime) - buffer->TimeGenerated;
							elapsedTime = gmtime(&eventTime);
							wcValues[wcYears] = elapsedTime->tm_year - 70;
							wcValues[wcDays] = elapsedTime->tm_yday;
							wcValues[wcHours] = elapsedTime->tm_hour;
							wcValues[wcMinutes] = elapsedTime->tm_min;
							wcValues[wcSeconds] = elapsedTime->tm_sec;
							if(lpFormat) {
								lpMsgBuf = (LPTSTR)malloc(strlen(lpFormat) + 1000);
								if(lpMsgBuf) {
									lpStrPos = lpMsgBuf;
									lpFormatPos = lpFormat;
									while(lpFormatPos[0]) {
										result = FALSE;
										switch(lpFormatPos[0]) {
											case '%':
												for(i = 0; i < wcCharCount; i++) {
													if(lpFormatPos[1] == wcChars[i]) {
														if(i != wcPercent) {
															itoa(wcValues[i], lpStrPos, 10);
															lpStrPos += strlen(lpStrPos);
														} else {
															lpStrPos[0] = wcChars[wcPercent];
															lpStrPos[1] = wcChars[wcPercent];
															lpStrPos += 2;
														}
														lpFormatPos++;
														result = TRUE;
														break;
													}
												}
												break;
											case '\\':
												for(i = 0; i < esCharCount; i++) {
													if(lpFormatPos[1] == esChars[i]) {
														lpStrPos[0] = esValues[i];
														lpStrPos++;
														lpFormatPos++;
														result = TRUE;
														break;
													}
												}
										}
										if(!result) {
											lpStrPos[0] = lpFormatPos[0];
											lpStrPos++;
										}
										lpFormatPos++;
									}
									lpStrPos[0] = 0;
									printf(lpMsgBuf);
									free(lpMsgBuf);
								} else {
									lpMsgBuf = strerror(GetLastError());
									if(lpMsgBuf) {
										printf(strings[strErrorMalloc], lpMsgBuf);
										LocalFree((LPVOID)lpMsgBuf);
									}
									returnCode = -1;
								}
							} else {
								if(arrayOut) {
									lpMsgBuf = strings[strOutputArray];
								} else {
									lpMsgBuf = strings[strOutputNormal];
								}
								printf(lpMsgBuf, elapsedTime->tm_year - 70, elapsedTime->tm_yday, elapsedTime->tm_hour, elapsedTime->tm_min, elapsedTime->tm_sec);
							}
							found = TRUE;
							break;
						}	
					}	
				}
				recordNumber--;
				result = ReadEventLog(hEventLog, EVENTLOG_SEEK_READ | EVENTLOG_BACKWARDS_READ, recordNumber, buffer, bufferSize, &bytesRead, &minNumberOfBytesNeeded);
			}
			free(buffer);
			if(!found) {
				lpMsgBuf = strerror(GetLastError());
				if(lpMsgBuf) {
					printf(strings[strErrorEvent6009], lpMsgBuf, minNumberOfBytesNeeded);
					LocalFree((LPVOID)lpMsgBuf);
				}
				returnCode = -1;
			}
		} else {
			lpMsgBuf = strerror(GetLastError());
			if(lpMsgBuf) {
				printf(strings[strErrorMalloc], lpMsgBuf);
				LocalFree((LPVOID)lpMsgBuf);
			}
			returnCode = -1;
		}
		CloseEventLog(hEventLog);
	} else {
		lpMsgBuf = strerror(GetLastError());
		if(lpMsgBuf) {
			printf(strings[strErrorOpenEventLog], lpMsgBuf);
			LocalFree((LPVOID)lpMsgBuf);
		}
		returnCode = -1;
	}

	return returnCode;
}
